/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2003 Matt Carter. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE   cout << "Test" << endl;
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

#include "oapr/oapr_app.hpp"
#include "oapr/oapr_exception.hpp"
#include "oapr/oapr_exc_utils.hpp"
#include "oapr/oapr_thread.hpp"
#include "apr_errno.h"
//#include "apr_time.h"
#include <iostream>

using namespace oapr;
using namespace std;

class test_class: public thread_class
{
  public:
    test_class(const pool::pool_ptr& p): thread_class(p) {}
  protected:
    apr_status_t execute();
  private:
    // My thread data
};

apr_status_t test_class::execute()
{
  cout << "Test" << endl;
  cout << "Test2" << endl;
//  OAPR_THROW(logic_error, "Test");
  cout << "Test3" << endl;
  return APR_SUCCESS;
}

int main(int argc,char*argv[])
{
  oapr_app app("thread test");
  pool::pool_ptr pl(new pool);
  cout << "Threading test. Starting 3 threads..." << endl << flush;
  try
  {
    {
      thread<test_class> t1(pl);
      thread<test_class> t2(pl);

      thread<test_class> t3(pl, false);
      t3.start();

    //apr_sleep(2000000);

      cout << "Before join and thread free." << endl << flush;
      //mythread t3;
    }
//    t1.join();
    //t2.join();
    //t3.join();

    cout << "Got past freeing of threads." << endl << flush;

  }catch(const exception_base &e){
    print_stack(&std::cerr,e);
    return 1;
  }catch(const std::exception &e){
    return 1;
  }catch(...){
    return 1;
  }
  return 0;
}
